import os
import re
import math
from typing import final
import bitstring

fileDir = os.path.dirname(os.path.abspath(__file__))
print(fileDir)
file = open(os.path.join(fileDir, "..\\dataset_raw.tsv"), "r")
results = open(os.path.join(fileDir, "testdata.txt"), "w")


# Converts the given integer to its boolean representation and returns it as an array.
def convertToBools(colInt):
    row = []
    for i in range(32):
        rest = colInt % 2
        row.append(rest)
        colInt = math.trunc(colInt/2)
    return row

# Converts the given float to its bitwise representation and returns it as an array.
def convertf32ToBools(num):
    result = []
    b = bitstring.pack('>f',num)
    blist = list(b)
    for char in blist:
        result.append(float(char))
    if (len(result) != 32):
        print("something went wrong converting f32 to bitarray")
    return result

# Checks if the given pattern consists of all zeroes.
def isEmptyRow(row):
    res = 0
    for step in row:
        res = res+step
    return res == 0

patternCounter = 0
non_empty_lines_emitted = 0
while(True):
    output = ""
    patternCounter += 1
    line = file.readline()
    if line == '':
        break
    fields = re.split('\t|,|\n| ', line)

    patternFields = fields[0:32]
    coords = fields[32:36]

    colArray = []
    for col in patternFields:
        colArray.append(convertToBools(int(col)))

    rowArray = []
    for step in range(14):
        row = []
        for col in range(32):
            row.append(colArray[col][step])
        rowArray.append(row)

    # reduce set to exactly 8 instruments
    counter = 0
    finalArray = []

    for row_ind in range(8):
        finalArray.extend(rowArray[row_ind])

    for row_ind in range (8,14):
        if(not isEmptyRow(rowArray[row_ind])):
            non_empty_lines_emitted = non_empty_lines_emitted + 1
            break

    #convert the latent space floats to binary 32-bit representation
    for latentCoord in coords:
        finalArray.extend(convertf32ToBools(float(latentCoord)))

    # output results to file
    for row in range(12):
        for step in range(32):
            output = output + str(finalArray[step+row*32]) + "," 
    results.write(output+"\n")

file.close()
results.close()
