import os
import re
import math
from typing import final

fileDir = os.path.dirname(os.path.abspath(__file__))
print(fileDir)
file = open(os.path.join(fileDir, "..\\dataset_raw.tsv"), "r")
results = open(os.path.join(fileDir, "testdata.txt"), "w")


# Converts the given integer to its boolean representation and returns it as an array.
def convertToBools(colInt):
    row = []
    for i in range(32):
        rest = colInt % 2
        row.append(rest)
        colInt = math.trunc(colInt/2)
    return row


# Checks if the given pattern consists of all zeroes.
def isEmptyRow(row):
    res = 0
    for step in row:
        res = res+step
    return res == 0


patternCounter = 0
while(True):
    output = ""
    patternCounter += 1
    line = file.readline()
    if line == '':
        break
    fields = re.split('\t|,|\n| ', line)
    patternFields = fields[0:32]
    coords = fields[32:36]
    colArray = []
    for col in patternFields:
        colArray.append(convertToBools(int(col)))

    rowArray = []
    for step in range(14):
        row = []
        for col in range(32):
            row.append(colArray[col][step])
        rowArray.append(row)

    # reduce set to exactly 8 instruments
    counter = 0
    binArray = []
    # leave out empty rows
    for row in rowArray:
        if not isEmptyRow(row):
            for step in row:
                binArray.append(step)
            if len(binArray) == 256:
                break
    # fill up whats left with empty rows
    while(len(binArray) < 256):
        binArray.append(0)

    #generate row-integers from the lines
    finalArray = []
    for row in range(8):
        rowint = 0
        for nstep in range(32):
            step = 31-nstep
            rowint = rowint+(2**step)*(binArray[row*32+nstep])
        finalArray.append(rowint)
        # output results to file
    for row in range(8):
        output = output + str(finalArray[row]) + ","
    output = output + "\n" + coords[0] + "," + coords[1] + "," + coords[2] + "," + coords[3] + "\n"
    results.write(output)

file.close()
results.close()
