import tensorflow.keras as keras
import tensorflow as tf
import random

#amount of epochs
epochs = 20

#batch_size per epoch
batch_size = 10000

# generates a random tuple with floats between 0 and 100000
def getRandomTuple():
    return [random.uniform(0,100000),random.uniform(0,100000)]

# returns the sum of the given numbers
def generate_result(x,y):
    return x + y

#create model for training
model = keras.Sequential([
    keras.layers.Dense(2,input_shape=[2]),
    keras.layers.Dense(32),
    keras.layers.Dense(1)
])
model.compile(optimizer="adam",loss="mean_absolute_error")
print(model.summary())

data = []
results = []
for batchnr in range(batch_size):
    newTupel = getRandomTuple()
    data.append(newTupel)
    results.append(generate_result(newTupel[0],newTupel[1]))

#fit model with generated training data
model.fit(data, results, epochs=epochs)

#convert model to tflite and save it as file
converter = tf.lite.TFLiteConverter.from_keras_model(model)
tflite_model = converter.convert()
open("initial_test.tflite", "wb").write(tflite_model)